-module(mup).
-behaviour(application).
-export([start/0, stop/0, reconfig/0]).
-export([start/2, start_phase/3, prep_stop/1, stop/1, config_change/3]).
-include("mup.hrl").


start() ->
    application:start(mup).

stop() ->
    application:stop(mup).

start(_StartType, _StartArgs) ->
    case mup_sup:start_link() of
        {ok, Pid} ->
            reconfig(),
            {ok, Pid};
        Other ->
            {error, Other}
    end.

start_phase(_Phase, _StartType, _PhaseArgs) ->
    ok.

prep_stop(State) ->
    State.

stop(_State) ->
    ignored.

config_change(_Changed, _New, _Removed) ->
    ok.


reconfig() ->
    mup_config:reconfig(),
    mup_server_sup:reconfig(),
    mup_plugin_sup:reconfig().
